#include "qspi_fun.h"
#if defined   (__CC_ARM) /*!< ARM Compiler */
#pragma O0
#elif defined (__GNUC__) /*!< GNU Compiler */
#pragma GCC optimize ("O0")
#endif /* __CC_ARM */

void QSPI_FunCnofig(void)//config
{
  GPIO_InitTypeDef GPIO_InitStructure;//GPIOʼṹ
	
  RCC->APB2ENR |= 0x1<<24;//QSPI enable
	RCC->AHB1ENR |= 0x1<<22;//DMA2  enable
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOD, ENABLE);
	
	GPIO_PinAFConfig(GPIOD, GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14, GPIO_AF_QSPI); 
	
	GPIO_InitStructure.GPIO_Pin  =  GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
  
	QSPI->GCTL = 0x1C;//ʹշܣʼ״̬8λģʽ
	QSPI->CCTL = 0x19;//mode0
	QSPI->SPBRG = 3;  //ٶ
	QSPI->SCSR = 0;
  QSPI->RXDNR = 1;

	QSPI->MODE = 0xC;//
  QSPI->GCTL |= 1;
  QSPI_FunRW(0);
	QFLASH_FunWriteCmd(0xE9);//Exit 4-Byte Address Mode

//	//Ĭϲܣֻ128M bit ϵFLASHҪֽģʽٷһֽڵĵַЧʻһ
//	QFLASH_FunWriteCmd(0xB7);//ַģʽ(4ֽڵַ֧128M bit ϵFLASH)
}

void QSPI_FunLine(u8 mode)//config
{
	if(mode == 2)
	{
		QSPI->MODE = 0xD;//
	}
	else if(mode == 4)
	{
		QSPI->MODE = 0xE;//
	}
	else
	{
		QSPI->MODE = 0xC;//
	}
}


void QSPI_FunRW(u8 rw)//send 8bit clk at switch to received
{
  QSPI->GCTL &= ~0x18;
  if(rw == 0)
  { 
    QSPI->GCTL |= 1<<3;
  }
  else
  {
    QSPI->GCTL |= 1<<4;//switch to received
  }
}

void QSPI_FunSendbyte(u8 data)//byte send
{
	QSPI->TXREG = data;
  while(!(QSPI->CSTAT & 0x1));
}

u8 QSPI_FunRecbyte(void)//byte send
{
  QSPI->RXDNR = 1;
	QSPI_FunRW(1);
  while(!(QSPI->CSTAT & 0x2));
  return QSPI->RXREG ;
}

void QSPI_FunSendGroup(u8* pData,u32 len)//group send
{
  #if 0
	while(len--)
  {
    QSPI_FunSendbyte(*pData++);
  }
  #else
  while(len --)
  {
    QSPI->TXREG = *pData++;
    while(!(QSPI->CSTAT & 0x1));
  }
  
  #endif
}

void QSPI_FunNSS(u8 cs)//qspi chip select
{
  if(cs == 0)
  {
    QSPI->SCSR = 0;
  }
  else
  {
    QSPI->SCSR = 1;
  }
}

void QSPI_FunDmaRxConfig(u32 adress,u32 len)//qspi rx dma
{

	QSPI_FunRW(1);//send 8bit clk at switch to received

	
	DMA2_Channel4->CMAR = adress;
	
	QSPI->RXDNR = len;
	DMA2_Channel4->CNDTR = len;  
	DMA2_Channel4->CCR |= 1;  
	

//	if(AI_Responder->CCR & 1)
//		{
//			AI_Responder_disable();
//			while((DMA2->ISR & 1<<13) == 0 );
//			AI_Responder_enable();
//		}
//	else 
		
	while((DMA2->ISR & 1<<13) == 0 );

	DMA2->IFCR = 1<<13;

}

  
#define QSPI_QUAL_READ 0   //Ƿ4QSPIʽ  0  1

void QFLASH_FunReadGroup(u32 add,u8 *pBuf,u32 len)
{
  u32 qFlashMaxLen = 0xFFFC;
	
	QSPI->SCSR = 1;
	QSPI->GCTL |= 1<<9;
	DMA2_Channel4->CCR = 0x280;
	DMA2_Channel4->CPAR = (u32)&(QSPI->RXREG);
  while(len)
  {
		QSPI_FunRW(0);
    QSPI->SCSR = 0; 
    #if (QSPI_QUAL_READ == 0)
    QSPI_FunSendbyte(RD_Com);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    #else
    QSPI_FunSendbyte(FastRD_QuadIo_Com);
    QSPI_FunLine(4);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    QSPI_FunSendbyte(0xF0);//M7-0
    QSPI_FunSendbyte(0);
    QSPI_FunSendbyte(0);
    #endif
		
    if(len >= qFlashMaxLen)
    {
      QSPI_FunDmaRxConfig((u32) pBuf, qFlashMaxLen);
      pBuf += qFlashMaxLen;
      len -= qFlashMaxLen;
    }
    else if(len)
    {
			QSPI_FunDmaRxConfig((u32) pBuf, len);
      len = 0;
    }
    
    QSPI->SCSR = 1; //һָȶȡCSˢһ
    #if (QSPI_QUAL_READ != 0)
    QSPI_FunLine(1);
    #endif
    add += qFlashMaxLen;
  }    
  QSPI_FunRW(0);
	
}
//pBuf׵ַҪ4ֽڶ룬㣬ʱ׵ַ4ֽڶ__attribute__((at(0x70250000)));⴮ֱ֤SDRAMΧڣܱ44ֽڶ
void QFLASH_FunReadGroup_Quad_REG(u32 add,u8 *pBuf,u32 len)
{
//  u32 qFlashMaxLen = 0xFFFC;//0xffffΪ4ֽڶ㷽㣬趨Ϊ0xFFFC
	u16 i;
	QSPI->SCSR = 1;
  while(len)
  {
		QSPI_FunRW(0);
		QSPI->SCSR = 0; 
		
    QSPI_FunSendbyte(FastRD_QuadIo_Com);
    QSPI_FunLine(4);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    QSPI_FunSendbyte(0xFf);//M7-0
    QSPI_FunSendbyte(0);
    QSPI_FunSendbyte(0);
		QSPI->GCTL|=Data_32bit;
		QSPI_FunRW(1);//send 8bit clk at switch to received
		
    if(len >= 0xFFFC)
    {
			
			QSPI->RXDNR = 0xFFFC;
			
			
			for(i=0;i<0xFFFC;i+=4)
			{
				while((QSPI_CSTAT & 0x08)==0x00);//ȴյ4ֽ
				*(u32*)(pBuf)=QSPI->RXREG;
				pBuf+=4;
			}
      len -= 0xFFFC;
			add += 0xFFFC;
    }
    else
    {
			 QSPI->RXDNR = len;
			 if(len&0xFFFC)
				{
					for(i=0;i<(len&0xFFFC);i+=4)
					{
						while((QSPI_CSTAT & 0x08)==0x00);
						*(u32*)(pBuf)=QSPI->RXREG;
						pBuf+=4;
					}
					len = len&0x3;
				}
			if(len)
			{
				QSPI->GCTL&=Data_8bit;  //л8λ󼸸
				while(len)
				{
					*(u8*)(pBuf++)=QSPI->RXREG;
					len--;
				}
			}

      len = 0;
    }
    
    QSPI->SCSR = 1; //һָȶȡCSˢһ
    QSPI_FunLine(1);
		QSPI->GCTL&=Data_8bit;
  }    
  QSPI_FunRW(0);
}
void QSPI_FunDmaRxConfig_Quad(u32 adress,u32 len)//qspi rx dma
{
	QSPI_FunRW(1);//send 8bit clk at switch to received
	QSPI->RXDNR = len;
	
	DMA2_Channel4->CMAR = adress;
	DMA2_Channel4->CNDTR = len>>2;  
	DMA2_Channel4->CCR |= 1;  
	
	while((DMA2->ISR & 1<<13) == 0 );
	DMA2->IFCR = 1<<13;
}
//ݴܲãֽڵĴüĴֱдʽ
//pBufַҪ4ֽڶ룬  u8 pBuf[4096]__attribute__((at(0x70250000)));   ⴮ֱ֤SDRAMΧڣܱ44ֽڶ
//ԭǣDMAһȡ4ֽڣҪ4ֽڶ
void QFLASH_FunReadGroup_Quad_DMA(u32 add,u8 *pBuf,u32 len)//4QSPI4ֽ32λDMAʽ
{
  u32 qFlashMaxLen = 0xFFFC;//0xffffΪ4ֽڶ룬趨Ϊ0xFFFC

	QSPI->SCSR = 1;
	DMA2_Channel4->CCR = 0xA80;
	DMA2_Channel4->CPAR = (u32)&(QSPI->RXREG);
	QSPI->GCTL |= 1<<9;
  while(len)
  {
		QSPI_FunRW(0);
    QSPI->SCSR = 0; 
    QSPI_FunSendbyte(FastRD_QuadIo_Com);
    QSPI_FunLine(4);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    QSPI_FunSendbyte(0xF0);//M7-0
    QSPI_FunSendbyte(0);
    QSPI_FunSendbyte(0);
		QSPI->GCTL|=Data_32bit;

		
    if(len >= qFlashMaxLen)
    {
      QSPI_FunDmaRxConfig_Quad((u32) pBuf, qFlashMaxLen);
      pBuf += qFlashMaxLen;
      len  -= qFlashMaxLen;
			add  += qFlashMaxLen;
    }
    else
    {
			if(len&0x3)
			{
				if(len&0xFFFC)QSPI_FunDmaRxConfig_Quad((u32) pBuf, len);//len4һȥDMA
				pBuf = pBuf +(len&0xFFFC);
				QSPI->GCTL&=Data_8bit;  //л8λ󼸸
				len=len&0x3;
				while(len)
				{
					*(u8*)(pBuf++)=QSPI->RXREG;
					len--;
				}
			}
			else if(len) 	QSPI_FunDmaRxConfig_Quad((u32) pBuf, len);
      len = 0;
    }
    
    QSPI->SCSR = 1; //һָȶȡCSˢһ
    QSPI_FunLine(1);
		QSPI->GCTL&=Data_8bit;
  }    
	QSPI->GCTL &= ~(1<<9);
  QSPI_FunRW(0);
}
//pBuf׵ַҪ4ֽڶ룬㣬ʱ׵ַ4ֽڶ__attribute__((at(0x70250000)));⴮ֱ֤SDRAMΧڣܱ44ֽڶ
void QFLASH_FunReadGroup_long_address_Quad_REG(u32 add,u8 *pBuf,u32 len)
{
//  u32 qFlashMaxLen = 0xFFFC;//0xffffΪ4ֽڶ㷽㣬趨Ϊ0xFFFC
	u16 i;
	QSPI->SCSR = 0; 
	QFLASH_FunWriteCmd(0xB7);//ַģʽ(4ֽڵַ֧128M bit ϵFLASH)
  while(len)
  {
		QSPI_FunRW(0);
		QSPI->SCSR = 0; 
		
    QSPI_FunSendbyte(FastRD_QuadIo_Com);
    QSPI_FunLine(4);
		QSPI_FunSendbyte(add>>24);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    QSPI_FunSendbyte(0xFf);//M7-0
    QSPI_FunSendbyte(0);
    QSPI_FunSendbyte(0);
		QSPI->GCTL|=Data_32bit;
		QSPI_FunRW(1);//send 8bit clk at switch to received
		
    if(len >= 0xFFFC)
    {
			
			QSPI->RXDNR = 0xFFFC;
			
			
			for(i=0;i<0xFFFC;i+=4)
			{
				while((QSPI_CSTAT & 0x08)==0x00);//ȴյ4ֽ
				*(u32*)(pBuf)=QSPI->RXREG;
				pBuf+=4;
			}
      len -= 0xFFFC;
			add += 0xFFFC;
    }
    else
    {
			 QSPI->RXDNR = len;
			 if(len&0xFFFC)
				{
					for(i=0;i<(len&0xFFFC);i+=4)
					{
						while((QSPI_CSTAT & 0x08)==0x00);
						*(u32*)(pBuf)=QSPI->RXREG;
						pBuf+=4;
					}
					len = len&0x3;
				}
			if(len)
			{
				QSPI->GCTL&=Data_8bit;  //л8λ󼸸
				while(len)
				{
					*(u8*)(pBuf++)=QSPI->RXREG;
					len--;
				}
			}

      len = 0;
    }
    
    QSPI->SCSR = 1; //һָȶȡCSˢһ
    QSPI_FunLine(1);
		QSPI->GCTL&=Data_8bit;
  }    
  QSPI_FunRW(0);
	QSPI->SCSR = 0;
	QFLASH_FunWriteCmd(0xE9);//Exit 4-Byte Address Mode ˳ַģʽ
	QSPI->SCSR = 1;
}
void QFLASH_FunReadGroup_long_address(u32 add,u8 *pBuf,u32 len)
{
	u32 qFlashMaxLen = 0xFFFF;//QSPI δ󳤶64K
	
	QSPI->SCSR = 1;
	QSPI->GCTL |= 1<<9;
	DMA2_Channel4->CCR = 0x280;
	DMA2_Channel4->CPAR = (u32)&(QSPI->RXREG);
	QSPI->SCSR = 0; 
	//Ĭϲܣֻ128M bit ϵFLASHҪֽģʽٷһֽڵĵַЧʻһ
	QFLASH_FunWriteCmd(0xB7);//ַģʽ(4ֽڵַ֧128M bit ϵFLASH)
  while(len)
  {
    QSPI->SCSR = 0; 
		QSPI_FunRW(0);
	#if (QSPI_QUAL_READ == 0)
    QSPI_FunSendbyte(RD_Com);
		QSPI_FunSendbyte(add>>24);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    #else
    QSPI_FunSendbyte(FastRD_QuadIo_Com);
    QSPI_FunLine(4);
    QSPI_FunSendbyte(add>>24);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    QSPI_FunSendbyte(0xF0);//M7-0
    QSPI_FunSendbyte(0);
    QSPI_FunSendbyte(0);
    #endif
    if(len > qFlashMaxLen)
    {
      QSPI_FunDmaRxConfig((u32) pBuf, qFlashMaxLen);
      pBuf += qFlashMaxLen;
      len -= qFlashMaxLen;
    }
    else
    {
      QSPI_FunDmaRxConfig((u32) pBuf, len);
      len = 0;
    }
    
    QSPI->SCSR = 1; 
    #if (QSPI_QUAL_READ != 0)
    QSPI_FunLine(1);
    #endif
    add += qFlashMaxLen;
  }    
  QSPI_FunRW(0);
	QSPI->SCSR = 0;
	QFLASH_FunWriteCmd(0xE9);//Exit 4-Byte Address Mode ˳ַģʽ
	QSPI->SCSR = 1;
}
void QSPI_PageProgram_Quad_REG(u32 add,u8*pBuf,uint32_t len)//Ĵʽ4QSPIдFLASH
{
    unsigned int j;
		QSPI->GCTL|=TXEN;
		while(len)
			{
				QFLASH_FunWriteCmd(WREN_Com);
				QSPI_SCSR&= CS_Low; 
				QSPI_FunSendbyte(PP_Com_Quad);
				QSPI_FunSendbyte(add>>16);
				QSPI_FunSendbyte(add>>8);
				QSPI_FunSendbyte(add);
				QSPI_MODE=0xe;
				if(len >= 256)
					{
						for(j=0;j<256;j++) QSPI_TXREG=*(u8*)(pBuf++);
						len -= 256;
						add += 256;
					}
				else if(len)
					{
						for(j=0;j<len;j++) QSPI_TXREG=*(u8*)(pBuf++);
						len = 0;
					}
				QSPI_SCSR|= CS_High;  //Spi cs assign to this pin,select
				QSPI->SCSR = 1; 
				QSPI_MODE=0xC; 
				QFLASH_FunCheckStatus();
			}
}

void QFLASH_FunProgram_Quad_DMA(u32 add,u8*pBuf,u32 len)//DMAʽ4QSPIдFLASH
{
	QSPI->SCSR = 1; 
	DMA2_Channel5->CCR = 0x290;//mem add disable
	DMA2_Channel5->CPAR = (u32)&(QSPI->TXREG);
	QSPI->GCTL |= 1<<9;
  while(len)
  {
    QSPI_FunRW(0);
    QFLASH_FunWriteCmd(WREN_Com);
 
    QSPI->SCSR = 0; 
    QSPI_FunSendbyte(PP_Com_Quad);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
		QSPI_MODE=0xe;
    if(len >= 256)//ҳдģʽһ256ֽڣҪֵҪȴFLASHдܽһҳ
    {
      QSPI_FunDmaTxConfig((u32) pBuf,256);
      pBuf += 256;
      len  -= 256;
			add  += 256;
    }
    else if(len)
    {
      QSPI_FunDmaTxConfig((u32) pBuf,len);
      len = 0;
    }
    QSPI->SCSR = 1; 
		QSPI_MODE=0xC; 
    QFLASH_FunWriteCmd(WRDI_Com); 
    QFLASH_FunCheckStatus();
  }
	QSPI->GCTL &= ~(1<<9);
}
void QSPI_FunDmaTxConfig(u32 adress,u32 len)//qspi tx dma
{
	DMA2_Channel5->CMAR = adress;
	DMA2_Channel5->CNDTR = len;
	DMA2_Channel5->CCR |= 1;
	
	while((DMA2->ISR & 1<<17) == 0 );
	DMA2->IFCR = 1<<17;
}
void QFLASH_FunProgram(u32 add,u8*pBuf,u32 len)//DMAʽQSPIдFLASHFLASHдҲ㹻ʤ
{
	DMA2_Channel5->CCR = 0x290;//mem add disable
	DMA2_Channel5->CPAR = (u32)&(QSPI->TXREG);
	QSPI->GCTL |= 1<<9;
  while(len)
  {
    QSPI_FunRW(0);
    QFLASH_FunWriteCmd(WREN_Com);
 
    QSPI->SCSR = 0; 
    QSPI_FunSendbyte(PP_Com);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    if(len >= 256)
    {
      QSPI_FunDmaTxConfig((u32) pBuf,256);
      pBuf += 256;
      len -= 256;
			add += 256;
    }
    else if(len)
    {
      QSPI_FunDmaTxConfig((u32) pBuf,len);
      len = 0;
    }
    QSPI->SCSR = 1; 
    QFLASH_FunWriteCmd(WRDI_Com); 
    QFLASH_FunCheckStatus();
  }
}
void QFLASH_FunProgram_long_address(u32 add,u8*pBuf,u32 len)
{
  u32 qFlashPage = 0x0100;
	DMA2_Channel5->CCR = 0x290;//mem add disable
	DMA2_Channel5->CPAR = (u32)&(QSPI->TXREG);
	QSPI->GCTL |= 1<<9;
	QSPI->SCSR = 0; 
	//Ĭϲܣֻ128M bit ϵFLASHҪֽģʽٷһֽڵĵַЧʻһ
	QFLASH_FunWriteCmd(0xB7);//ַģʽ(4ֽڵַ֧128M bit ϵFLASH)
  while(len)
  {
    QSPI_FunRW(0);
  
    QFLASH_FunWriteCmd(WREN_Com);
 
    QSPI->SCSR = 0; 
    QSPI_FunSendbyte(PP_Com);
		QSPI_FunSendbyte(add>>24);
    QSPI_FunSendbyte(add>>16);
    QSPI_FunSendbyte(add>>8);
    QSPI_FunSendbyte(add);
    if(len > qFlashPage)
    {
      QSPI_FunDmaTxConfig((u32) pBuf,qFlashPage);
      pBuf += qFlashPage;
      len -= qFlashPage;
    }
    else
    {
      QSPI_FunDmaTxConfig((u32) pBuf,len);
      len = 0;
    }
    add += qFlashPage;
    QSPI->SCSR = 1; 
    QFLASH_FunWriteCmd(WRDI_Com); 
    QFLASH_FunCheckStatus();
  }
	QSPI->SCSR = 0;
	QFLASH_FunWriteCmd(0xE9);//Exit 4-Byte Address Mode ˳ַģʽ
	QSPI->SCSR = 1;
}
void QFLASH_FunErase(u32 add,u8 eType)//eType 0:SE_Com (Erase 4KB), 1:BE64K_Com
{
  unsigned char addr0,addr1,addr2;
  add = add&0x00ffffff; 
  addr0 = (add>>16)&0xff;
  addr1 = (add>>8)&0xff;
  addr2 = (add)&0xff;

  QSPI_FunRW(0);

  QFLASH_FunWriteCmd(WREN_Com);// Write Enable

  QSPI->SCSR = 0;
  
  if(eType == 0)
  {
    QSPI_FunSendbyte(SE_Com);//Erase 4KB
  }
  else
  {
    QSPI_FunSendbyte(BE64K_Com);//Erase 64KB
  }
  
  QSPI_FunSendbyte(addr0);
  QSPI_FunSendbyte(addr1);
  QSPI_FunSendbyte(addr2);

  QSPI->SCSR = 1;
  QFLASH_FunWriteCmd(WRDI_Com); 
  QFLASH_FunCheckStatus();
}
void QFLASH_FunErase_long_address(u32 add,u8 eType)//eType 0:SE_Com (Erase 4KB), 1:BE64K_Com
{
	
  QSPI_FunRW(0);
	QSPI->SCSR = 0;
	QFLASH_FunWriteCmd(WREN_Com);// Write Enable
  QFLASH_FunWriteCmd(0xB7);//ַģʽ(4ֽڵַ֧128M bit ϵFLASH)
  QSPI->SCSR = 0;
  if(eType == 0)
  {
    QSPI_FunSendbyte(SE_Com);//Erase 4KB
  }
  else
  {
    QSPI_FunSendbyte(BE64K_Com);//Erase 64KB
  }
  QSPI_FunSendbyte(add>>24);
  QSPI_FunSendbyte(add>>16);
  QSPI_FunSendbyte(add>>8);
  QSPI_FunSendbyte(add);

  QSPI->SCSR = 1;
  QFLASH_FunWriteCmd(WRDI_Com); 
  QFLASH_FunCheckStatus();
	QSPI->SCSR = 0;
	QFLASH_FunWriteCmd(0xE9);//Exit 4-Byte Address Mode ˳ַģʽ
	QSPI->SCSR = 1;
}
void QFLASH_FunEraseAll(void)
{
  QSPI_FunRW(0);
  QFLASH_FunWriteCmd(WREN_Com);
  QFLASH_FunWriteCmd(CE_Com); 
  QFLASH_FunCheckStatus();
}

void QFLASH_FunReadId(u8* id)
{
  
}

void QFLASH_FunWriteCmd(u8 cmd)
{
  QSPI->SCSR = 0;
  QSPI_FunSendbyte( cmd);
  QSPI->SCSR = 1;
}
void QFLASH_FunCheckStatus(void)
{
  u8 tempData;
	QSPI_FunRW(0);
	QSPI->SCSR = 0;
	QSPI_FunSendbyte( RDSR_Com);
  while(1)
  {  
    tempData = QSPI_FunRecbyte();
    if((tempData & 0x1) == 0)
    {
      
      break;
    }
  }
	QSPI->SCSR = 1;

}

//ȡļַ*sΪļظļĵַ
int get_file_address_NOR_FLASH(char *s)
{
	u8 temp[4096];
	int i,j,k;

	QFLASH_FunReadGroup_Quad_REG(0xF000, temp, 4096);//ȡļͷ

	for(i=1;i<=temp[6];i++)
	{
		if((temp[16*i]==*s)||(temp[16*i]==*s-32))//ִСдĸ
		{
			for(j=0;j<13;j++)
			{
				if(temp[16*i+j]==0)
				{
					k = (temp[16*i+13]<<16)+(temp[16*i+14]<<8)+temp[16*i+15];//ƴӳַŵK

					return k;//ظļַ
				}
				if((temp[16*i+j]!=*(s+j))&&(temp[16*i+j]!=(*(s+j)-32))) break;
			}	
		}	
	}	
	return 0;
}



